Attribute VB_Name = "basRobs"
' -------------------------------------------------------------------------
'
' basRobs(ftRobsTS.BAS)                              Ulrich Mller  5.10.98
'                                                    Dell XPS P90     VB5.0
' ftRobs : Globale Definitionen und Routinen
'
' -------------------------------------------------------------------------

Option Explicit


Public Declare Function CloseHandle Lib "kernel32" _
  (ByVal hObject As Long) As Long
Public Declare Function CreateThread Lib "kernel32" _
  (ByVal lpThreadAttributes As Long, ByVal dwStackSize As Long, _
  ByVal lpStartAddress As Long, lpParameter As Long, _
  ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
Public Declare Function ResumeThread Lib "kernel32" _
  (ByVal hThread As Long) As Long
Public Declare Function SuspendThread Lib "kernel32" _
  (ByVal hThread As Long) As Long
Public Declare Function SetThreadPriority Lib "kernel32" _
  (ByVal hThread As Long, ByVal nPriority As Long) As Long
Public Declare Sub ExitThread Lib "kernel32" (ByVal dwExitCode As Long)
Public Declare Function TerminateThread Lib "kernel32" _
  (ByVal hThread As Long, ByVal dwExitCode As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Const CREATE_SUSPENDED = &H4
Public Const THREAD_PRIORITY_IDLE = -15
Public Const THREAD_PRIORITY_TIME_CRITICAL = 15
Public Const THREAD_PRIORITY_NORMAL = 0

Public Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" _
  (ByVal lpEventAttributes As Long, ByVal bManualReset As Long, _
  ByVal bInitialState As Long, ByVal lpName As String) As Long
Public Declare Function ResetEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Public Declare Function PulseEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Public Declare Function SetEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" _
  (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function WaitForMultipleObjects Lib "kernel32" _
  (ByVal nCount As Long, lpHandles As Long, ByVal bWaitAll As Long, _
  ByVal dwMilliseconds As Long) As Long
  
Public Const INFINITE = -1&
Public Const WAIT_TIMEOUT = &H102&
Public Const WAIT_OBJECT_0 = 0&
Public Const WAIT_FAILED = -1&

Public Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

Public Type ProcStep
  StepTyp As Integer
  Wert1 As Integer
  Wert2 As Integer
  Wert3 As Integer
  Wert4 As Integer
  Anmerkung As String * 40
End Type

' --------- Programmglobale Konstanten -----

Public Const cftTitel$ = "fischertechnik Industry Robots"

Public Const cFarbeEin = &HFF00&
Public Const cFarbeAus = &H8000000F
Public Const cFarbeAusH = &HE0E0E0
Public Const cFarbeEnde = &H80C0FF
Public Const cFarbeFehler = &HFF8&
Public Const cFarbeTonne = &HFFFF&

' ----- Roboter Konstanten ---

Public Const cRSchwenkMotor = 1
Public Const cRSchwenkELinks = 1
Public Const cRSchwenkERechts = 2
Public Const cRGreiferMotor = 2
Public Const cRGreiferOffen = 3
Public Const cRGreiferImpuls = 4
Public Const cRGreiferEndPosition = 28

' -------- Programmglobale Variable -------

Public rbPortName$(1 To 4)        ' --- COM-Name der RobPorts
Public rbNotHalt As Boolean       ' --- allgemeines NotHalt

Public rb(1 To 4) As clsFishFace  ' --- FishFace-Instanzen fr die Robs
Public rbEvent(1 To 4) As Long    ' --- Eventvariable fr die Robs
Public rbSecurity As SECURITY_ATTRIBUTES
Public rbThread(1 To 4) As Long   ' --- Thread-Handle fr Rob-FahrAuftrge
Public rbThreadID(1 To 4) As Long ' --- Thread ID
Public rbFertig(1 To 4) As Long   ' --- Thread beendet
Public rbWiederEnde As Boolean    ' --- Endlosschleife beenden
Public rbWiederEnde2 As Boolean   '     Teil 2
Public rbNr&                      ' --- Nr des aktuellen Robs

Public Const maxStep = 100
Public PfadName$
Public ProcTab(1 To maxStep) As ProcStep
Public ProcStart(1 To 5) As Integer


Public Function DriveRob(ByVal r As Long) As Long

' --- Betreiben eines Robs nach ProcTab unter Threadbedingungen ---
'     Ende : chkWieder oder Nothalt

Dim s&, i&

  frmRobs.lblRobStatus(r) = "Programm gestartet"
  ResetEvent rbFertig(r)
   
  Do                                             ' --- Endlosschleife
    WaitForSingleObject rbEvent(r), INFINITE     ' --- Warten auf Akvirung von Auen
    If rbWiederEnde And r = 3 Then               ' --- Abbruchanforderung fr Rob3
      rbWiederEnde2 = True                       ' --- Abbruchanforderung fr alle
      For i = 1 To 4
        SetEvent rbEvent(i)                      '     Signal Event fr alle
      Next i
      Exit Do
    End If
    If rbNotHalt Or rbWiederEnde2 Then Exit Do   ' --- Eigener Abbruch
    frmRobs.lblRobPosition(r).BackColor = cFarbeEin
        
' --- Abarbeiten des Scriptfiles (Teil fr Rob r) ---

    For s = ProcStart(r) To ProcStart(r + 1) - 1
      If rbNotHalt Then Exit Do
      frmRobs.lblRobPosition(r) = s
      frmRobs.lblRobStatus(r) = ProcTab(s).Anmerkung
      
      Select Case ProcTab(s).StepTyp
      Case 1                    ' --- Fahren ---
        If r = 2 Then           ' --- Schwei-Roboter
          rb(r).SetMotor rb(r).MotCntl.Nr(4), ProcTab(s).Wert4
          rb(r).MoveTo ProcTab(s).Wert1, ProcTab(s).Wert2, ProcTab(s).Wert3
        Else
          rb(r).MoveTo ProcTab(s).Wert1, ProcTab(s).Wert2, ProcTab(s).Wert3, ProcTab(s).Wert4
        End If
      Case 3                    ' --- Event ---
        If ProcTab(s).Wert1 = r Then
          frmRobs.lblRobPosition(r).BackColor = cFarbeEnde
          WaitForSingleObject rbEvent(r), INFINITE     ' --- Parken eigener Thread
          frmRobs.lblRobPosition(r).BackColor = cFarbeEin
        Else
          If ProcTab(s).Wert2 = 1 Then
            SetEvent rbEvent(ProcTab(s).Wert1)         ' --- Aktivieren fremder Thread
          Else
            ResetEvent rbEvent(ProcTab(s).Wert1)       ' --- Parken fremder Thread
          End If
        End If
      End Select
    Next s
    
     frmRobs.lblRobPosition(r).BackColor = cFarbeEnde
   Loop While (frmRobs.chkWieder.Value = 1)
  
  
  frmRobs.lblRobStatus(r) = "Programm " & IIf(rbNotHalt, "abgebrochen", "beendet")
  frmRobs.lblRobPosition(r).BackColor = cFarbeEnde
  
  DriveRob = r
  SetEvent rbFertig(r)            ' --- Fertigmeldung fr ProgrammLoop
  ExitThread ByVal r
  
End Function

Public Function DriveSchwenk(ByVal r As Long) As Long

' --- Tonne wenden von linken auf den rechten Teller ---
'     Threadbedingung, Ende : chkWieder oder NotHalt

  frmRobs.lblRobStatus(r) = "Programm gestartet"
  ResetEvent rbFertig(r)
  Do
    WaitForSingleObject rbEvent(r), INFINITE
    If rbNotHalt Or rbWiederEnde2 Then Exit Do
    frmRobs.lblRobPosition(r).BackColor = cFarbeEin

  ' --- Schwenk rechts ----
  
    rb(r).SetMotor cRSchwenkMotor, ftiRechts
    Do
    Loop Until rb(r).GetInput(cRSchwenkERechts) Or rbNotHalt
    rb(r).SetMotor cRSchwenkMotor, ftiAus
    frmRobs.lblRobPosition(r) = "re"
    frmRobs.lblRobStatus(r) = "Greifer rechts"
    
  ' --- Greifer zu ----
    
    rb(r).SetMotor cRGreiferMotor, ftiRechts
    rb(r).WaitForChange cRGreiferImpuls, cRGreiferEndPosition
    rb(r).SetMotor cRGreiferMotor, ftiAus
    frmRobs.lblRobPosition(r) = "zu"
    frmRobs.lblRobStatus(r) = "Greifer geschlossen"
    
  ' --- Schwenk links ---
  
    rb(r).SetMotor cRSchwenkMotor, ftiLinks
    Do
    Loop Until rb(r).GetInput(cRSchwenkELinks) Or rbNotHalt
    rb(r).SetMotor cRSchwenkMotor, ftiAus
    frmRobs.lblRobPosition(r) = "li"
    frmRobs.lblRobStatus(r) = "Greifer links"
    
  ' --- Greifer auf ---
  
    rb(r).SetMotor cRGreiferMotor, ftiLinks
    Do
    Loop Until rb(r).GetInput(cRGreiferOffen) Or rbNotHalt
    rb(r).SetMotor cRGreiferMotor, ftiAus
    frmRobs.lblRobPosition(r) = "auf"
    frmRobs.lblRobStatus(r) = "Greifer offen"
    
  ' --- Rob2 starten ---
  
    SetEvent rbEvent(2)
    
  ' --- Schwenk Mitte ---
  
    rb(r).SetMotor cRSchwenkMotor, ftiRechts
    rb(r).WaitForTime 5555
    rb(r).SetMotor cRSchwenkMotor, ftiAus
    frmRobs.lblRobStatus(r) = "Greifer in Parkposition"
    frmRobs.lblRobPosition(r) = "mi"
    frmRobs.lblRobPosition(r).BackColor = cFarbeEnde
  
  Loop While frmRobs.chkWieder.Value = 1

  frmRobs.lblRobStatus(r) = "Programm " & IIf(rbNotHalt, "abgebrochen", "beendet")
  DriveSchwenk = r
  SetEvent rbFertig(r)
  ExitThread ByVal r
  
End Function

Public Function InitRob(ByVal pp&) As Long

' --- Rob p auf Home-Position fahren (unter Threadbedingungen) ---

Dim p&

  p = Abs(pp)
  
' --- Greifer auf ---
  
  If p > 2 Then
    rb(p).SetMotor rb(p).MotCntl.Nr(4), ftiLinks
    Do
    Loop Until rb(p).GetInput(Abs(rb(p).MotCntl.Ende(4))) Or rbNotHalt
    rb(p).MotCntl.Position(4) = 0
  End If
  rb(p).SetMotor rb(p).MotCntl.Nr(4), ftiAus
  
' --- Arm zurck ---

  rb(p).SetMotor rb(p).MotCntl.Nr(2), ftiLinks
  Do
  Loop Until rb(p).GetInput(Abs(rb(p).MotCntl.Ende(2))) Or rbNotHalt
  rb(p).MotCntl.Position(2) = 0
  rb(p).SetMotor rb(p).MotCntl.Nr(2), ftiAus
  
' --- Arm auf ---

  rb(p).SetMotor rb(p).MotCntl.Nr(3), ftiLinks
  Do
  Loop Until rb(p).GetInput(Abs(rb(p).MotCntl.Ende(3))) Or rbNotHalt
  rb(p).MotCntl.Position(3) = 0
  rb(p).SetMotor rb(p).MotCntl.Nr(3), ftiAus
  
' --- Sule links ---

  rb(p).SetMotor rb(p).MotCntl.Nr(1), ftiLinks
  Do
  Loop Until rb(p).GetInput(Abs(rb(p).MotCntl.Ende(1))) Or rbNotHalt
  rb(p).MotCntl.Position(1) = 0
  rb(p).SetMotor rb(p).MotCntl.Nr(1), ftiAus
  
  InitRob = p
  If pp > 0 Then ExitThread ByVal p

End Function


Public Function InitRob1(ByVal pp&) As Long

' --- Rob1 auf Home-Position fahren ---

Dim p&

  p = Abs(pp)                    ' --- RobNr, positiv, wenn Thread
  
' --- Greifer auf ---

  rb(1).SetMotor cRGreiferMotor, ftiLinks
  Do
  Loop Until rb(1).GetInput(cRGreiferOffen) Or rbNotHalt
  rb(1).SetMotor cRGreiferMotor, ftiAus
  
' --- Schwenk links ---

  rb(1).SetMotor cRSchwenkMotor, ftiLinks
  Do
  Loop Until rb(1).GetInput(cRSchwenkELinks) Or rbNotHalt
  rb(1).SetMotor cRSchwenkMotor, ftiAus
  
  InitRob1 = p
  If pp > 0 Then ExitThread ByVal p
  
End Function

Public Sub OneRob(r&)

' --- Manueller Betrieb eines Robs nach ProcTab fr Testzwecke ---

Dim s&

  frmRobs.lblRobStatus(r) = "Programm gestartet"
  frmRobs.lblRobPosition(r).BackColor = cFarbeEin
  For s = ProcStart(r) To ProcStart(r + 1) - 1
    If rbNotHalt Then Exit Sub
    If ProcTab(s).StepTyp = 1 Then       ' --- nur Fahrauftrge
      frmRobs.lblRobPosition(r) = s
      frmRobs.lblRobStatus(r) = ProcTab(s).Anmerkung
      If r = 2 Then           ' --- Schwei-Roboter
        rb(r).SetMotor rb(r).MotCntl.Nr(4), ProcTab(s).Wert4
        rb(r).MoveTo ProcTab(s).Wert1, ProcTab(s).Wert2, ProcTab(s).Wert3
      Else
        rb(r).MoveTo ProcTab(s).Wert1, ProcTab(s).Wert2, ProcTab(s).Wert3, ProcTab(s).Wert4
      End If
    End If
  Next s
  
  frmRobs.lblRobStatus(r) = "Programm beendet"
  frmRobs.lblRobPosition(r).BackColor = cFarbeEnde

End Sub


